/// @cond EO_CXX_EO_IMPL

inline void elm::notify::dismiss() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_notify_dismiss());
}

inline void elm::notify::align_get(double* horizontal_, double* vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_notify_align_get(horizontal_, vertical_));
}

inline void elm::notify::align_set(double horizontal_, double vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_notify_align_set(horizontal_, vertical_));
}

inline bool elm::notify::allow_events_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_notify_allow_events_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::notify::allow_events_set(bool allow_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_notify_allow_events_set(::efl::eolian::to_c(allow_)));
}

inline double elm::notify::timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_notify_timeout_get());
   return _tmp_ret;
}

inline void elm::notify::timeout_set(double timeout_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_notify_timeout_set(timeout_));
}

inline void eo_cxx::elm::notify::dismiss() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_notify_dismiss());
}

inline void eo_cxx::elm::notify::align_get(double* horizontal_, double* vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_notify_align_get(horizontal_, vertical_));
}

inline void eo_cxx::elm::notify::align_set(double horizontal_, double vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_notify_align_set(horizontal_, vertical_));
}

inline bool eo_cxx::elm::notify::allow_events_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_notify_allow_events_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::notify::allow_events_set(bool allow_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_notify_allow_events_set(::efl::eolian::to_c(allow_)));
}

inline double eo_cxx::elm::notify::timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_notify_timeout_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::notify::timeout_set(double timeout_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_notify_timeout_set(timeout_));
}

inline ::eo_cxx::elm::notify::operator ::elm::notify() const
{
   return *static_cast<::elm::notify const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::notify::operator ::elm::notify&()
{
   return *static_cast<::elm::notify*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::notify::operator ::elm::notify const&() const
{
   return *static_cast<::elm::notify const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_notify_dismiss_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->dismiss();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_notify_align_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double* horizontal_, double* vertical_)
{
   try
      {
         static_cast<T*>(self->this_)->align_get(horizontal_, vertical_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_notify_align_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double horizontal_, double vertical_)
{
   try
      {
         static_cast<T*>(self->this_)->align_set(horizontal_, vertical_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_notify_allow_events_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->allow_events_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_notify_allow_events_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool allow_)
{
   try
      {
         static_cast<T*>(self->this_)->allow_events_set(::efl::eolian::to_cxx<bool>(allow_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_notify_timeout_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->timeout_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_notify_timeout_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double timeout_)
{
   try
      {
         static_cast<T*>(self->this_)->timeout_set(timeout_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::notify >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::container >::template type<T>
   {
      virtual void dismiss()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_notify_dismiss());
      }

      virtual void align_get(double* horizontal_, double* vertical_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_notify_align_get(horizontal_, vertical_));
      }

      virtual void align_set(double horizontal_, double vertical_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_notify_align_set(horizontal_, vertical_));
      }

      virtual bool allow_events_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_notify_allow_events_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void allow_events_set(bool allow_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_notify_allow_events_set(::efl::eolian::to_c(allow_)));
      }

      virtual double timeout_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_notify_timeout_get());
            return _tmp_ret;
      }

      virtual void timeout_set(double timeout_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_notify_timeout_set(timeout_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::notify >
{
   static constexpr int value = 
#if defined(NOTIFY_PROTECTED) && defined(NOTIFY_BETA)
      7
#elif defined(NOTIFY_PROTECTED)
      7
#elif defined(NOTIFY_BETA)
      7
#else
      7
#endif
      + operation_description_class_size<::elm::container >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::notify>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_notify_dismiss_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_dismiss);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_notify_align_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_align_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_notify_align_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_align_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_notify_allow_events_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_allow_events_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_notify_allow_events_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_allow_events_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_notify_timeout_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_timeout_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_notify_timeout_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_timeout_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::container>(), &ops[operation_description_class_size< ::elm::notify >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::notify>)
{
   return (ELM_NOTIFY_CLASS);
}

} } }

/// @endcond

